const jsonDiff = require('json-diff');
const axios = require('axios')
const diffFiles = (name, f1, f2)=>{
  
  var p = [
   
    axios.get(f2).then(res => res.data)
  ]
  if(typeof f1 == 'object'){
    p.push(f1)
  }
  else{
    p.push( axios.get(f1).then(res => res.data).catch(e=>{}) )
  }
  if(typeof f2 == 'object'){
    p.push(f2)
  }
  else{
    p.push( axios.get(f2).then(res => res.data).catch(e=>{}) )
  }
  return Promise.all(p).then(files=>{
    return {name: name, diff:jsonDiff.diffString(files[0], files[1])};
  })
  .catch(e=>{return {name:name, diff:e}})
}

const findDiff = (files)=>{
  const keys = Object.keys(files)
  console.log(keys)
  let p = []
  for(let i = 0; i<keys.length; i++){
    const key = keys[i]
    const val = files[key]
    console.log(files[i])
    if(Array.isArray(val) && val.length === 2){
      p.push(
        diffFiles(key, val[0],val[1])
        .then(diff=>'============= '+diff.name+' =============\n'+diff.diff)
        .catch(e=>"Err")
      )
    }
  
    else if(Array.isArray(val) && val.length === 3){
      const path =  val[2].replace(/^\//,'')
      const host1 = val[0].replace(/\/$/,'')+'/'+path
      const host2 = val[1].replace(/\/$/,'')+'/'+path
      p.push( 
        diffFiles(key, host1,host2)
        .then(diff=>'============= '+diff.name+' =============\n'+diff.diff)
        .catch(e=>"Err")
      )
    }
  }
  return Promise.all(p).then(diffs=>diffs.join('\n'))
}


const files = {
  feed:['https://jsonplaceholder.typicode.com/photos/1', 'https://jsonplaceholder.typicode.com/photos/2'],
  feed2:['http://alpha.mysite.com', 'http://mysite.com','/feeds/90212e56-9762-490c-aa69-b399d9f09485']
}

findDiff(files).then(console.log)





//console.log(jsonDiff.diff({ foo: 'bar' }, { foo: 'baz' }));